#include <stdio.h>
#include <string.h>
#include <stdlib.h>

static const unsigned char puzzli2_tab[256] = {
	0xb7, 0x66, 0xa3, 0xc0, 0x51, 0x55, 0x6d, 0x63, 0x86, 0x60, 0x64, 0x6c, 0x67, 0x18, 0x0b, 0x05,
	0x62, 0xff, 0xe0, 0x1e, 0x30, 0x21, 0x2e, 0x40, 0x41, 0xb9, 0x60, 0x38, 0xd1, 0x24, 0x7e, 0x36,
	0x7a, 0x0b, 0x1c, 0x69, 0x4f, 0x09, 0xe1, 0x9e, 0xcf, 0xcd, 0x7c, 0x00, 0x73, 0x08, 0x77, 0x37,
	0x5f, 0x50, 0x32, 0x3e, 0xd3, 0x54, 0x77, 0x6b, 0x60, 0x60, 0x74, 0x7c, 0x55, 0x4f, 0x44, 0x5e,
	0x66, 0x5c, 0x58, 0x26, 0x35, 0x29, 0x3f, 0x35, 0x3f, 0x1c, 0x0b, 0x0d, 0x08, 0x5b, 0x59, 0x5c,
	0xa0, 0xa5, 0x87, 0x85, 0x24, 0x75, 0x5f, 0x42, 0x1b, 0xf3, 0x1a, 0x58, 0x17, 0x58, 0x71, 0x6b,
	0x69, 0x89, 0x7d, 0x3a, 0xf3, 0xc4, 0x5d, 0xa0, 0x4f, 0x27, 0x58, 0xc4, 0xa8, 0xdd, 0xa8, 0xfb,
	0xbe, 0xa4, 0xe2, 0xee, 0x07, 0x10, 0x90, 0x72, 0x99, 0x08, 0x68, 0x6d, 0x5c, 0x5c, 0x6d, 0x58,
	0x2f, 0xdc, 0x15, 0xd5, 0xd6, 0xd6, 0x3b, 0x3b, 0xf9, 0x32, 0xcc, 0xdd, 0xd4, 0xf1, 0xea, 0xed,
	0xe4, 0xf6, 0xf2, 0x91, 0xca, 0xc1, 0xed, 0xf2, 0xf6, 0xfb, 0xc0, 0xe8, 0xe3, 0xe7, 0xfa, 0xf1,
	0xf5, 0x08, 0x26, 0x2b, 0x2f, 0x34, 0x39, 0x13, 0x28, 0x07, 0x88, 0x5b, 0x8f, 0x94, 0x9b, 0x2e,
	0xf5, 0xab, 0x72, 0x76, 0x7a, 0x40, 0xb9, 0x09, 0xd8, 0x3b, 0xcd, 0x31, 0x3d, 0x42, 0xab, 0xb1,
	0xb5, 0xb9, 0x3b, 0xe3, 0x0b, 0x65, 0x18, 0xfb, 0x1f, 0x12, 0xe4, 0xe8, 0xec, 0xf2, 0xf7, 0xfc,
	0xc0, 0xe8, 0xe0, 0xe6, 0xfa, 0xf1, 0xf4, 0x0b, 0x26, 0x2b, 0x30, 0x35, 0x39, 0x13, 0x29, 0x21,
	0x0c, 0x11, 0x16, 0x1b, 0x1f, 0x64, 0x0e, 0x60, 0x05, 0x79, 0x7c, 0x37, 0x00, 0x0f, 0x4f, 0x38,
	0x1d, 0x18, 0xa2, 0xb6, 0xb2, 0xa9, 0xac, 0xab, 0xae, 0x91, 0x98, 0x8d, 0x91, 0xbb, 0xb1, 0xc0
};

static void pgm_decrypt_puzzli2(unsigned short *src)
{
	int i;
	for (i = 0; i < 0x100000/2; i++) {
		unsigned short x = src[i];

	    if ((i & 0x040080) != 0x000080) x ^= 0x0001;
	    if ((i & 0x004008) == 0x004008) x ^= 0x0002;
	    if ((i & 0x000030) == 0x000010) x ^= 0x0004;
	    if ((i & 0x000242) != 0x000042) x ^= 0x0008;
	    if ((i & 0x008100) == 0x008000) x ^= 0x0010;
	    if ((i & 0x022004) != 0x000004) x ^= 0x0020;
	    if ((i & 0x011800) != 0x010000) x ^= 0x0040;
	    if ((i & 0x004820) == 0x004820) x ^= 0x0080;

    	x ^= puzzli2_tab[i & 0xff] << 8;

		src[i] = x;
	}
}


static unsigned char get_char(char *ptr)
{
	unsigned char i, ret = 0;
	for (i = 0; i < 2; i++, *ptr++)
	{
		ret <<= 4;
		if ((*ptr & 0xf0) == 0x30 && (*ptr & 0xf) < 10) ret |= (*ptr & 0xf);
		if ((*ptr & 0xd0) == 0x40 && (*ptr & 0xf) > 0 && (*ptr & 0xf) < 7) ret |= ((*ptr & 0x7) + 9);
	}

	return ret;
}

static int get_s_record(unsigned char *dest)
{
	char line[128];

	FILE *fa = fopen("puzzli2_protection.s68", "rt");
	if (fa == NULL) {
		printf ("Failed to open puzzli2_protection.s68.\n");
		return 1;
	}

	printf (" - Importing \'S\' record.\n");

	while (1)
	{
		if (fgets (line, 128, fa) == NULL) break;

		char *ptr = line;
		while (*ptr == ' ' || *ptr == '\t') ptr++;
		if (*ptr != 'S') continue; // ??
		ptr++; // past 's' (1 byte)

		if (*ptr != '1' && *ptr != '2' && *ptr != '3') continue;

		unsigned char address_size = (*ptr & 3) + 1; ptr++;
		unsigned int address = 0;
		unsigned char bytecount = get_char(ptr); ptr += 2;
		unsigned char checksum = bytecount;

		while (address_size)
		{
			address <<= 8;
			address |= get_char(ptr);
			checksum += address & 0xff;
			ptr+=2;
			address_size--;
			bytecount--;
		}

		bytecount--;

		while (bytecount)
		{
			dest[address ^ 1] = get_char(ptr);
			ptr += 2;
			checksum += dest[address ^ 1];
			address++;
			bytecount--;
		}

		unsigned char chk = get_char(ptr);
		checksum ^= 0xff;
		if (chk != checksum)
		{
			printf ("checksum failed! Expected: %2.2x Calculated: %2.2x\n", chk, checksum ^ 0xff);			
			break;
		}
	}

	fclose (fa);
	
	return 0;
}


#define RAM_ADDRESS	0x818000

static void patch(unsigned char *src, int region)
{
	pgm_decrypt_puzzli2((unsigned short*)src);

	{
		int i;
		unsigned short *rom = (unsigned short*)src;
		
		get_s_record(src + 0x020000);
		//FILE *fb = fopen("puzzli2_protection.bin", "rb");
		//fseek (fb, 0, SEEK_END);
		//int plen = ftell (fb);
		//rewind (fb);
		//fread (src + 0x020000, plen, 1, fb);
		//fclose (fb);
		//for (i = 0x20000/2; i < (0x20000 + plen)/2; i++) {
		//	rom[i] = (rom[i] << 8) | (rom[i] >> 8);
		//}

		// patch out irq4 (find first RTE and point to it)
//		for (i = 0; i < 0x200000/2; i++) {
//			if (rom[i] == 0x4e73) {
//				rom[0x70/2] = ((i * 2) >> 16) + 0x10;
//				rom[0x72/2] = i * 2;
//				break;
//			}
//		}

		for (i = 0; i < 0x100000/2; i++)
		{
			if (i >= (0x20000/2) && i < (0x22000/2)) continue;

			// patch out protection integrity checks
			if ((rom[i] & 0xff00) == 0x6000) {
				int j, k, r, f = 0;
				for (j = 0; j < 32; j++)
				{
					if (((rom[i+j] & 0xf1f0) == 0xb0a0 && rom[i+j+1] >= 0xf000 && (rom[i+j+2] & 0xff00) == 0x6500) ||
						((rom[i+j] & 0xf1f8) == 0xb080 && (rom[i+j+1] & 0xff00) == 0x6500))
					{
						for (k = 0, r = 0; k < 32; k++)
						{
							if ((rom[i+j+k] & 0xff00) == 0x6600)
							{
								f = i + j + k;
								r++;
							}
							if ((rom[i+j+k] & 0xff00) == 0x6700 && r == 1)
							{
							// printf ("%5.5x\n", i*2);
							// test 1, branch past doing the check
							//	rom[i] &= 0xff00;
							//	rom[i+1] = ((j + k) * 2) + (rom[i+j+k] & 0xff);
							// test 2, do the check, but ignore test results
								rom[f] = 0x6002;//4e71;
								rom[i+j+k] &= 0xf0ff;
								j = 1000;
								break;
							}
						}
					}
				}
			}

			// move.w D0, $500000	- store protection value
			if (rom[i] == 0x33c0 && rom[i+1] == 0x0050 && rom[i+2] == 0x0000) {
				rom[i+1] = RAM_ADDRESS >> 16;
				rom[i+2] = RAM_ADDRESS + 0x100;
			}
			
			// move.w	D0, $500002 - store command and key (in high byte)
			if (rom[i] == 0x33c0 && rom[i+1] == 0x0050 && rom[i+2] == 0x0002) {
				rom[i+0] = 0x4eb9;
				rom[i+1] = 0x0012;
				rom[i+2] = 0x0002;
			}
			
			// move.w  $815bc6.l, $500000.l - store protection values moved from fixed ram addresses
			if (rom[i] == 0x33f9 && rom[i+3] == 0x0050 && rom[i+4] == 0x0000) {
				rom[i+3] = RAM_ADDRESS >> 16;
				rom[i+4] = RAM_ADDRESS+0x100;
			}
			
			// move.w  #$ffc7, $500002.l - process hard-coded 'reset' command
			if (rom[i] == 0x33fc && rom[i+1] == 0xffc7 && rom[i+2] == 0x0050 && rom[i+3] == 0x0002) { 
				rom[i+0] = 0x4eb9;
				rom[i+1] = 0x0012;
				rom[i+2] = 0x0004;
				rom[i+3] = 0x4e71;
			}

			// move.w	$500002.l, D0 - point protection read (low) directly to response
			if ((rom[i] & 0xf0ff) == 0x3039 & rom[i+1] == 0x0050 && rom[i+2] == 0x0002) {
				rom[i+1] = RAM_ADDRESS >> 16;
				rom[i+2] = RAM_ADDRESS+0x104;
			}

			// move.w	$500000.l, D0 - point protection read (high) directly to response
			if ((rom[i] & 0xf0ff) == 0x3039 & rom[i+1] == 0x0050 && rom[i+2] == 0x0000) {
				rom[i+1] = RAM_ADDRESS>>16;
				rom[i+2] = RAM_ADDRESS+0x106;
			}

			// clr.w   $500004.l	- nop out protection completed(?) command
		//	if (rom[i] == 0x4279 && rom[i+1] == 0x50 && rom[i+2] == 0x0004) {
		//		rom[i+0] = 0x4e71;
		//		rom[i+1] = 0x4e71;
		//		rom[i+2] = 0x4e71;
		//	}
			
			// move.w  $4f0008.l, D0 - move region byte
			if (rom[i] == 0x3039 && rom[i+1] == 0x004f && rom[i+2] == 0x0008) {
				rom[i+1] = 0x12;
				rom[i+2] = 0x0000;
			}
		}
		
		// region byte!
		rom[0x20000/2] = region;
	}
}

int main()
{
	int i;
	FILE *fa, *fb, *fc;
	unsigned char *src;
	char type[4], region[4];

	printf ("Select ROM type:\n");
	printf ("  0 = Puzzli 2 only\n");
	printf ("  1 = Puzzli 2 Super\n");
	printf ("  2 = Puzzli 2 & Puzzli 2 Super\n");
	gets (type);
	if ((type[0] & 0xf0) != 0x30 || (type[0] & 0x0f) > 2) {
		printf ("Invalid ROM type selected! (%x)\n", type[0] - 0x30);
		return 1;
	}

	printf ("\nSelect Region:\n");
	printf ("  0 = Taiwan\n");
	printf ("  1 = China\n");
	printf ("  2 = Japan\n");
	printf ("  3 = Korea\n");
	printf ("  4 = Hong Kong\n");
	printf ("  5 = World\n");
	gets (region);
	if ((region[0] & 0xf0) != 0x30 || (region[0] & 0x0f) >= 6) {
		printf ("Invalid region selected! (%x)\n", region[0]-0x30);
		return 1;
	}
	
	type[0] &= 3;
	region[0] &= 7;

	src = (unsigned char*)malloc(0x200000);
	
	if (type[0] == 0)
	{
		fa = fopen("v100.u5", "rb");
		if (fa == NULL) {
			printf ("v100.u5 not found!\n");
			free (src);
			return 1;
		}
		fread (src, 0x100000, 1, fa);
		fclose (fa);

		patch(src, region[0] & 7);
		
		fa = fopen("puzzli2-deprotected.bin", "wb");
		fwrite (src, 0x100000, 1, fa);
		fwrite (src, 0x100000, 1, fa);
		fwrite (src, 0x100000, 1, fa);
		fwrite (src, 0x100000, 1, fa);
		fclose (fa);
	}
	else if (type[0] == 1)
	{
		fa = fopen("2sp_v200.u4", "rb");
		if (fa == NULL) {
			printf ("2sp_v200.u4 not found!\n");
			free (src);
			return 1;
		}
		fb = fopen("2sp_v200.u3", "rb");
		if (fb == NULL) {
			printf ("2sp_v200.u3 not found!\n");
			return 1;
		}

		for (i = 0; i < 0x100000; i+=2)
		{
			fread (src + i + 0, 1, 1, fa);
			fread (src + i + 1, 1, 1, fb);
		}
		fclose (fa);
		fclose (fb);

		patch(src, region[0] & 7);
		
		fa = fopen("puzzli2s-deprotected.bin", "wb");
		fwrite (src, 0x100000, 1, fa);
		fwrite (src, 0x100000, 1, fa);
		fwrite (src, 0x100000, 1, fa);
		fwrite (src, 0x100000, 1, fa);
		fclose (fa);
	}
	else if (type[0] == 2)
	{
		fa = fopen("v100.u5", "rb");
		if (fa == NULL) {
			printf ("v100.u5 not found!\n");
			free (src);
			return 1;
		}
		fread (src, 0x100000, 1, fa);
		fclose (fa);

		patch(src, region[0] & 7);

		fa = fopen("2sp_v200.u4", "rb");
		if (fa == NULL) {
			printf ("2sp_v200.u4 not found!\n");
			free (src);
			return 1;
		}
		fb = fopen("2sp_v200.u3", "rb");
		if (fb == NULL) {
			printf ("2sp_v200.u3 not found!\n");
			return 1;
		}

		for (i = 0; i < 0x100000; i+=2)
		{
			fread (src + 0x100000 + i + 0, 1, 1, fa);
			fread (src + 0x100000 + i + 1, 1, 1, fb);
		}
		fclose (fa);
		fclose (fb);

		patch(src + 0x100000, region[0] & 7);
		
		fc = fopen("puzzli2_and_super-deprotected.bin", "wb");
		fwrite (src, 0x100000, 1, fc);
		fwrite (src, 0x100000, 1, fc);
		fwrite (src + 0x100000, 0x100000, 1, fc);
		fwrite (src + 0x100000, 0x100000, 1, fc);
		fclose (fc);
	}
	
	free (src);
	
	return 1;
}
